#define F(X)   80 * ((X)<16) + 30 + 20*sin((float)X*(2*PI/T*10)) + 10*sin((float)X*(2*PI/T*5))

//#define F(X)  (float)X * slope + dc + amp * exp(-(float)X/var_exp)*sin(((float)X)/20)
#define AAA 128
//#define F(X)   100 * ((X)<AAA) * (1+cos((X-AAA/2)*(2*3.1416/AAA)))

#define AA   100
#define WW   2*PI/256
//#define F(X)     AA*sin((X)*WW) + AA/3*sin((X)*WW*3) + AA/5*sin((X)*WW*5) + AA/7*sin((X)*WW*7) + AA/9*sin((X)*WW*9)

#define T 256
#define N 256


#define W (2*PI/T)


int f[660];
float a[N], b[N], amp[N], phi[N];

#define OX 0
#define OY 240

//#include"key_code.h"
#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>

#define PI 3.14159

void inicia_graficos(void);
void keyboard(void);
void define_function(void);
void print_function(void);
void calc_fourier(void);
void print_fourier_spectrum(void);
void print_fourier_function(void);
void print_text(void);


void main(void) {

	inicia_graficos();

	define_function();
	calc_fourier();

//	print_text();

	print_function();
	print_fourier_spectrum();
	print_fourier_function();

	#define XX 0
	#define YY 300
	#define DD 16
	setcolor(YELLOW);
	outtextxy(XX,YY,"f(x) = 80 * (x<16) + 30 + 20*sin(x*(2*PI/T*10)) + 10*sin(x*(2*PI/T*5))");

	setcolor(GREEN);
	outtextxy(XX,YY+2*DD,"Reconstructed f(x)");

	setcolor(CYAN);
	outtextxy(XX,YY+3*DD,"A(n)");

	setcolor(MAGENTA);
	outtextxy(XX,YY+4*DD,"Phi(n)");



	getch();

	closegraph();

}

void define_function(void) {
	int x;

	for(x=0; x<T; x++) {
		f[x] = F(x);
	}
}


void print_function(void) {
	int x;

	setcolor(WHITE);
	line(OX, OY, 640, OY);

	for(x=0; x<T; x++) {
		putpixel(OX + x, OY - f[x], YELLOW);
	}
}

void calc_fourier(void) {
	int i,t;
	float aux_a, aux_b;

	for(i=1; i<N; i++) {
		aux_a = 0;
		aux_b = 0;

		for(t=0; t<T; t++) {
			aux_a += (float)f[t] * sin(i*W*t);
			aux_b += (float)f[t] * cos(i*W*t);
		}
		a[i] = 2 * aux_a / T;
		b[i] = 2 * aux_b / T;

		amp[i] = sqrt(a[i]*a[i] + b[i]*b[i]);
		phi[i] = atan(b[i] / (.0000001+a[i]));

		amp[0]=0;
		for(t=0; t<T; t++) amp[0] += f[t];
		amp[0] /= T;

	}
}

void print_fourier_spectrum(void) {
	int i;

	setcolor(CYAN);
	for(i=0; i<N; i++) {
		line(360+i, OY, 360+i, OY - (int)(amp[i]*8));
		if(amp[i]>1 || amp[i]<-1) putpixel(360+i, OY-(int)(phi[i]*(360/2/PI)), MAGENTA);
	}

}


void print_fourier_function(void) {
	int i,t;
	double aux_f;

	for(t=0; t<T; t++) {
		aux_f = amp[0];
		for(i=1; i<N/2; i++) {
			aux_f += amp[i] * sin(i*W*t+phi[i]);
		}
		putpixel(OX+t, OY-aux_f, GREEN);
	}
}


void print_text(void) {
	int i;
	gotoxy(1,1);

	for(i=0; i<20; i++) {
		if(amp[i]>1) printf("A[%2.0i]=%3.0f      phi[%2.0i]=%3.0f\n", i, amp[i], i, phi[i]*360.0/2/PI);
	}
}


void keyboard(void) {
	int c;

	for(;;) {

		if((c=getch())==0) c=getch()<<8;

		switch(c) {
			case 0x1b:
				return;

		}
		cleardevice();


	}
}

void inicia_graficos(void) {

   /* request auto detection */
   int gdriver = DETECT, gmode, errorcode;

   /* initialize graphics mode */
   initgraph(&gdriver, &gmode, "X:\\APPS\\TCPP\\BGI");

   /* read result of initialization */
   errorcode = graphresult();

   if (errorcode != grOk)  /* an error occurred */
   {
      printf("Graphics error: %s\n", grapherrormsg(errorcode));
      printf("Press any key to halt:");
      getch();
      exit(1);             /* return with error code */
   }

}

